config/routes.rb
Rails.application.routes.draw do
  devise_for :users
  root to: 'staff/dashboard#show' 
  # For details on the DSL available within this file, see http://guides.rubyonrails.org/routing.html

  namespace :staff do
    resource :dashboard, controller: :dashboard do
      collection do
        get :tats
        get :reports
        get :staffs_report
        get :executives_report
      end
    end
      resources :cases do
      collection do
        get :upload_file
        post :upload_mapping
        post :upload
        get :search
        put :bulk_assignment
        get :out_of_tats
        get :today_tats
        get :tomorrow_tats
      end
      member do
        get  :mark_approved
        post :upload_attachment
        post :upload_verification_detail
        get :crop_attachment
      end

      resources :attachments
    end
    resources :clients
    resources :users
  end

  namespace :executive do
    resources :cases do
      collection do
        get :verification_completed
        get :print_all
      end
      member do
        post :upload_attachment
        get :template
        post :upload_verification_detail
        get  :mark_verification_completed
        get :redo
        post :set_untraceable
      end
    end
  end
end

app/controllers/executive/cases_controller.rb
class Executive::CasesController < ApplicationController

  def new
  end

  def index
    @cases = Case.where(user_id: current_user, status: "in_progress").order(created_at: :desc)
  end

  def show
    @case = Case.find(params[:id])
    @case_investigation = CaseInvestigation.find_by(case_id: @case.id, user_id:  @case.user_id)
    unless @case_investigation.present?
      @case_investigation = CaseInvestigation.new
    end
  end

  def template  
    @case = Case.find(params[:id])
    render layout: 'print'
  end

  def upload_verification_detail
    @case = Case.find(params[:id])
    @verified_case = CaseInvestigation.find_by(case_id: @case.id, user_id: @case.user_id)
    
    if attachment_params.present?
      upload_attachment
    end

    if params[:case_investigation].present?
      if @verified_case.present?
        @verified_case = @verified_case.update_attributes(case_investigation_params)
      else
        @verified_case = CaseInvestigation.new(case_investigation_params)
        @verified_case.case_id = @case.id
        @verified_case.user_id = @case.user_id
        @verified_case.save!
      end
    end

    redirect_back(fallback_location: executive_case_path(@case))
  end

  def mark_verification_completed
    @case = Case.find(params[:id])
    @case.status = "verification_completed"
    @case.save!
    redirect_to executive_cases_path
  end

  def verification_completed
    @cases = Case.where(user_id: current_user, status: ["approved", "verification_completed"])
  end

  def redo
    @case = Case.find(params[:id])
    @case.status = "in_progress"
    @case.save!
    redirect_to executive_case_path(@case)
  end

  def set_untraceable
    @case = Case.find(params[:id])
    @untraceable_case = CaseInvestigation.find_by(case_id: @case.id, user_id: @case.user_id)
    
    if @untraceable_case.present?
      @untraceable_case.update_attributes(case_investigation_params)
    else 
      @untraceable_case  = CaseInvestigation.new(case_investigation_params)
      @untraceable_case.case_id = @case.id
      @untraceable_case.user_id = current_user.id
      @untraceable_case.save!
    end

    @case.status = "verification_completed"
    @case.is_untraceable = true
    @case.save!
    redirect_to executive_case_path(@case)
  end

  def print_all
    @cases = Case.where(user_id: current_user, status: "in_progress")
    render layout: 'print'
  end

  private

  def attachment_params
    params.require(:attachments).map{|p| p.permit(:document)} if params[:attachments].present?
  end

  def case_investigation_params
    params.require(:case_investigation).permit(:visited_at, :address_changed, :land_mark, :locality, :accommodation_type, :duration_of_stay, :building_color, :building_type, :id_number, :respondent_name, :respondent_relationship, :respondent_contact_no, :police_station_name, :remarks, :untraceable, extras: {})
  end

  def upload_attachment
    attachment_params.each do |attach_param|
      if attach_param[:document].present?
        attachment = Attachment.new(attach_param)
        attachment.case_id = @case.id
        attachment.user_id = current_user.id
        attachment.save!
      end
    end
  end

end

app/controllers/staff/attachments_controller.rb
class Staff::AttachmentsController < ApplicationController
  before_action :find_case
  before_action :find_attachment

  def show
  end

  private
    def find_case
      @case = Case.find params[:case_id]
    end

    def find_attachment
      @attachment = @case.attachments.find params[:id]
    end
end

app/controllers/staff/cases_controller.rb
class Staff::CasesController < ApplicationController
  require 'csv'

  before_action :find_case, only: %w(show crop_attachment)

  include UploadMappings

  def index
    @users = User.where(role: 'executive')
    @clients =Client.all
    @cases = Case.where.not(status: 'approved').order(created_at: :desc)
  end

  def tats
  end

  def out_of_tats
    @users = User.where(role: 'executive')
    @cases = Client.total_out_of_tats
    render action: :index
  end

  def today_tats 
    @users = User.where(role: 'executive')
    @cases = Client.total_tats_today
    render action: :index
  end

  def tomorrow_tats
    @users = User.where(role: 'executive')
    @cases = Client.total_tats_tomorrow
    render action: :index
  end

  def upload_file
    @clients = Client.all
  end

  def upload_mapping
    @clients = Client.all
    if params[:csv].present?
      @csv = CSV.parse(params[:csv].read, headers: true)
      @client = Client.find(params[:client_id])
      fn = "upload_mapping_#{@client.client_format}_#{params[:case_type]}"
      if respond_to?(fn)
        if (@cases = send(fn))
          session[:cases] = @cases
        else
          render action: :upload_file
        end
      else
        flash[:notice] = "Selected type is not supported"
        render action: :upload_file
      end
    else
      flash[:notice] = "Please upload the file"
      render action: :upload_file
    end
  end

  def upload
    session[:cases].each do |c|
      #ca = Case.find_or_initialize_by(client_ref_no: c['client_ref_no'])
      #ca.attributes = c
      #ca.save!
      c.stringify_keys!
      @cases = Case.find_by(client_ref_no: c['client_ref_no'])
      if @cases.present?
        @cases.update_attributes(c)
      else
        Case.open.create!(c)
      end
    end
    redirect_to staff_cases_path
  end

  def show 
    @case = Case.find(params[:id])
    @case_investigation = CaseInvestigation.find_by(case_id: @case.id, user_id:  @case.user_id)
    unless @case_investigation.present?
      @case_investigation = CaseInvestigation.new
    end
  end


  def upload_attachment
    attachment_params.each do |attach_param|
      if attach_param[:document].present?
        attachment = Attachment.new(attach_param)
        attachment.case_id = @case.id
        attachment.user_id = current_user.id
        attachment.save!
      end
    end
  end

  def upload_verification_detail
    @case = Case.find(params[:id])
    @verified_case = CaseInvestigation.find_by(case_id: @case.id, user_id: @case.user_id)

    if @verified_case.present?
      @verified_case = @verified_case.update_attributes(case_investigation_params)
    else
      @verified_case = CaseInvestigation.new(case_investigation_params)
      @verified_case.case_id = @case.id
      @verified_case.user_id = current_user.id
      @verified_case.save!
    end
    redirect_to staff_case_path(@case)
  end


  def mark_approved
    @case = Case.find(params[:id])
    if @case.status == "verification_completed"
      @case.staff_id = current_user.id
      @case.status = "approved"
      @case.save!
    end
      redirect_to staff_cases_path
  end

  def search
    params[:search] ||= {}
    @users = User.where(role: 'executive')
    @cases = Case.where("1=1")
    @cases = @cases.where(status: params[:search][:status]) if params[:search][:status].present?
    
    if params[:search][:query].present?
      query = '%' + params[:search][:query] + '%'
      @cases = @cases.where("address ILIKE ?", query)
    end

    if params[:search][:client_id].present?
      @cases = @cases.where(client_id: params[:search][:client_id])
    end

    if params[:search][:user_id].present?
      @cases = @cases.where(user_id: params[:search][:user_id])
    end

    if params[:search][:case_type].present?
      @cases = @cases.where(case_type: params[:search][:case_type]) 
    end

    respond_to do |format|
      format.html { render action: :index }
      format.csv { send_data @cases.to_csv, filename: "cases-#{Date.today}.csv" }
    end
  end




  def bulk_assignment
    if params[:case_ids].present?
      params[:case_ids].each do |case_id|
        c = Case.find(case_id)
        c.update_attributes user_id: params[:user_id], status: "in_progress"
      end
    else
      flash[:notice] = "select cases"
    end
    redirect_to staff_cases_path
  end

  def crop_attachment
    @attachment = @case.attachments.find(params[:attachment_id])
  end

  def attachment_params
    params.require(:attachments).map{|p| p.permit(:document)}
  end

  def case_investigation_params
    params.require(:case_investigation).permit(:visited_at, :address_changed, :land_mark, :locality, :accommodation_type, :duration_of_stay, :building_color, :building_type, :id_number, :respondent_name, :respondent_relationship, :respondent_contact_no, :police_station_name, :remarks, extras: {})
  end

  def find_case
    @case = Case.find(params[:id])
  end
end

app/controllers/staff/clients_controller.rb
class Staff::ClientsController < ApplicationController

  def new
    @client = Client.new
  end

  def create
    @client = Client.new(client_params)
    if @client.save
      redirect_to staff_clients_path
    else
      render action: :new
    end
  end

  def index
    @clients = Client.all.order(created_at: :asc)
  end

  def update
    @client = Client.find(params[:id])
    if @client.update_attributes(client_params)
        flash[:success]="Successfully updated"
        redirect_to staff_clients_path()
      else
        render 'edit'
    end
  end 

  def edit
    @client = Client.find(params[:id])
  end

  private

    def client_params
      params.require(:client).permit(:name,:email,:client_format)
    end
end

app/controllers/staff/dashboard_controller.rb
class Staff::DashboardController < ApplicationController

  def show
    @cases = Case.all
    @executives = User.where(role: 'executive')
    @staffs = User.where(role: 'staff')
  end



  def reports
  end

  def staffs_report
    @user = User.find(params[:staff_id])
    @cases = Case.where(staff_id: @user.id, status: ["approved"])
    render action: :reports
  end

  def executives_report
    @user = User.find(params[:executive_id])
    @cases = Case.where(user_id: @user.id, status: ["approved", "verification_completed"])
    render action: :reports
  end

end

app/controllers/staff/users_controller.rb
class Staff::UsersController < ApplicationController

  def new
    @user = User.new()
  end

  def create
    @user = User.new(user_params)
    respond_to do |format|
      if @user.save
        redirect_to staff_users_path
        else
        render action: :new
      end
    end 
  end

  def index
    @users = User.all.order(created_at: :asc)
  end


  def update
    @user = User.find(params[:id])
    @user.update_attributes(user_params)
    render 'edit'
  end 


  def edit
    @user = User.find(params[:id])
  end

  private

    def user_params
      params.require(:user).permit(:name, :l_name, :dob, :id_proof, :photo,  :email, :password, :phone, :address, :role, :password_confirmation)
    end

end

app/helpers/executive/cases_helper.rb
module Executive::CasesHelper
end

app/helpers/staff/attachments_helper.rb
module Staff::AttachmentsHelper
end

app/helpers/staff/cases_helper.rb
module Staff::CasesHelper
end

app/helpers/staff/clients_helper.rb
module Staff::ClientsHelper
end

app/helpers/staff/dashboard_helper.rb
module Staff::DashboardHelper
end

app/helpers/staff/users_helper.rb
module Staff::UsersHelper
end

app/views/staff/cases/_case_formats_preview.html.erb
<div id="securitas_address" class="format-previews">
	<label>Required file format preview for uploading Securitas address cases:</label>
	<table border="1">
		<tr>
			<td>Name</td>
			<td>CompanyRefNo</td>
			<td>Father Name</td>
			<td>address</td>
			<td>AV_Pincode</td>
			<td>Location</td>
			<td>StateName</td>
			<td>MobileNo</td>
			<td>Allocation Date</td>
		</tr>
	</table>
</div>

<div id="securitas_employment" class="format-previews">
	<label>Required file format preview for uploading Securitas employment cases:</label>
	<table border="1">
		<tr>
			<td>Securitas Ref No.</td>
			<td>Candidate Name</td>
			<td>Company name</td>
			<td>Address</td>
			<td>Location</td>
			<td>Received Date</td>
		</tr>
	</table>
</div>

<div id="footprints_address" class="format-previews">
	<label>Required file format preview for uploading Footprints address cases:</label>
	<table border="1">
		<tr>
			<td>Check Id</td>
			<td>Name</td>
			<td>Address</td>
			<td>Contact No</td>
			<td>CS SENT DT</td>
		</tr>
	</table>
</div>

<div id="footprints_employment" class="format-previews">
	<label>Required file format preview for uploading Footprints employment cases:</label>
	<table border="1">
		<tr>
			
		</tr>
	</table>
</div>

<div id="pinkerton_address" class="format-previews">
	<label>Required file format preview for uploading Pinkerton address cases:</label>
	<table border="1">
		<tr>
			<td>Candidate Name</td>
			<td>Order ID</td>
			<td>Father Name</td>
			<td>Address</td>
			<td>City</td>
			<td>State</td>
			<td>Contact No<td>
			<td>Date of Birth</td>
			<td>Allocated date</td>
		</tr>
	</table>
</div>

<div id="pinkerton_employment" class="format-previews">
	<label>Required file format preview for uploading Pinkerton employment cases:</label>
	<table border="1">
		<tr>
			<td>Order id</td>
			<td>Duration</td>
			<td>Designation</td>
			<td>Subject's Name</td>
			<td>Name of Organization</td>
			<td>Address to be verified</td>
		</tr>
	</table>
</div>

<div id="asd_address" class="format-previews">
	<label>Required file format preview for uploading ASD address cases:</label>
	<table border="1">
		<tr>
			<td>Client name</td>
			<td>ASD ID</td>
			<td>Applicant's Name</td>
			<td>Father's Name</td>
			<td>Address</td>
      		<td>Applicant Contact Detail</td>
      		<td>Allocation Date</td>
		</tr>
	</table>
</div>

<div id="asd_employment" class="format-previews">
	<label>Required file format preview for uploading ASD employment cases:</label>
	<table border="1">
		<tr>
			<td>ASD ID</td>
			<td>APPLICANT NAME</td>
			<td>ORGANIZATION NAME</td>
			<td>Address</td>
			<td>DESIGNATION</td>
			<td>EMPCODE</td>
			<td>TENURE</td>
			<td>allow date</td>
		</tr>
	</table>
</div>

<div id="decode_address" class="format-previews">
	<label>Required file format preview for uploading Decode address cases:</label>
	<table border="1">
		<tr>
			<td>Ref. Number</td>
			<td>Client Name</td>
			<td>Candidate Name</td>
			<td>Fathers Name</td>
			<td>Permanent Address</td>
			<td>Phone Numbers</td>
			<td>allow date</td>
		</tr>
	</table>
</div>


<div id="acheck_address" class="format-previews">
	<label>Required file format preview for uploading Acheck address cases:</label>
	<table border="1">
		<tr>
			<td>Client Ref ID</td>
			<td>Client Name</td>
			<td>Candidate Name</td>
			<td>Father's Name</td>
			<td>Address</td>
			<td>Contact Details</td>
			<td>SENT DATE</td>
		</tr>
	</table>
</div>

<div id="acheck_employment" class="format-previews">
	<label>Required file format preview for uploading Acheck employment cases:</label>
	<table border="1">
		<tr>
			<td>Client Ref ID</td>
			<td>COMPANY NAME</td>
			<td>CANDIADTE MANE</td>
			<td>ADDRESS</td>
			<td>CONTACTNO</td>
			<td>SENT DATE</td>
		</tr>
	</table>
</div>

<div id="authbridge_employment" class="format-previews">
	<label>Required file format preview for uploading Authbridge employment cases:</label>
	<table border="1">
		<tr>
			<td>ARS</td>
          	<td>COMPANY NAME</td>
          	<td>COMPANY ADDRESS</td>
        	<td>Pin code</td>
			<td>City</td>
			<td>State</td>
			<td>Tenure</td>
			<td>Designation</td>
			<td>Employee Code</td>
			<td>Reason For Leaving</td>
			<td>Last drawn salary by the Applicant (Annual Gross)</td>
			<td>Subject Name</td>
			<td>Contact No.</td>
		</tr>
	</table>
</div>

app/views/staff/cases/index.html.erb
<div class="row">
  <div class="col">
    <div class="card card-small mb-4">
      <div class="card-header border-bottom">
        <%= form_for OpenStruct.new(params[:search]), as: :search, url: search_staff_cases_path, method: :get do |f| %>
        <%= link_to "Upload cases", upload_file_staff_cases_path, class: "mb-2 btn btn-outline-primary mr-2", style: "float: right;"%>
        <div class="row">
          <div class="col-xl-2", style="padding-right: 0px;">
          <%= f.select :client_id, Client.all.collect{|c| [c.name, c.id]}, {:include_blank => '-- Client --'}, class: 'form-control' %>
          </div>
          <div class="col-xl-2", style="padding-right: 0px;">
          <%= f.select :status, Case::STATUSES.collect{|k,v| [v, k]}, {:include_blank => '-- Status --'},class: 'form-control' %>
          </div>
          <div class="col-xl-2", style="padding-right: 0px;">
          <%= f.select :case_type, Case::CASE_TYPES.collect{|k,v| [v, k]}, {:include_blank => '-- Case Type-'},class: 'form-control' %>
          </div>
           <div class="col-xl-2", style="padding-right: 0px;">
          <%= f.select :user_id, User.where(role: 'executive').collect{|u| [u.name, u.id]}, {:include_blank => '-- Executive --'},class: 'form-control' %>
          </div>
          <div class="col-xl-2", style="padding-right: 0px;">
            <%= f.text_field :query, placeholder: "Search Address", class: 'form-control' %>
          </div>
          <div class="col-xl-2", style="padding-right: 0px;">
            <%= submit_tag "Filter", class: 'btn btn-accent' %>
          </div>
        </div>
        <% end %>
      </div>

      <% if @cases.present? %>
        <%= form_for :cases, url: bulk_assignment_staff_cases_path, method: :PUT do |f| %>
        <div style="float: right; padding-right: 20px; padding-top: 25px;"><%= link_to "Download as CSV", search_staff_cases_path(format: "csv", search: params[:search]&.to_enum.to_h) %></div>

        <div class="row", style="margin: 1%;">
          <div class="col-xl-3" style="padding-right: 0px;">
          <%= select_tag :user_id, options_for_select([['--Executive--', nil]] + @users.collect{|u| [u.name, u.id]}), class: 'form-control'  %>
          </div>
          <div>
          <%= f.submit 'Assign', class: 'btn bg-info text-white' %>
          </div>
        </div>

        <div class="card-body p-0 pb-3 text-center">
          <table class="table mb-0">
            <thead class="bg-light">
              <tr>
                <th class="border-0"></th>
                <th class="border-0">Received Date</th>
                <th class="border-0" style="width: 200px;">Candidate/Address</th>
                <th class="border-0">Client Name</th>
                <th class="border-0">Ref No</th>
                <th class="border-0">Executive/Status</th>
                <th class="border-0"></th>
              </tr>
            </thead>
            <tbody>
              <% @cases.each do |c| %>
                <tr>
                  <td>
                    <div class="custom-control custom-checkbox mb-1">
                      <%= check_box_tag 'case_ids[]', c.id, false, id: "checkbox-#{c.id}", class: "custom-control-input" %>
                      <%= label_tag '', '', class: "custom-control-label", for: "checkbox-#{c.id}" %>
                    </div>
                  </td>
                  <td>
                    <%= c.received_date %><br />
                    <% if c.out_of_tat?.present? %>
                      <span class="badge badge-pill badge-danger", style="margin-top: 5px;">Out of tat</span>
                    <% end %>
                  </td>
                  <td><%= link_to staff_case_path(c) do %><%= c.candidate_name %><br /><small style="color: #5a6169;"><%= c.address %></small><% end %></td>
                  <td> <%= c.client.name %> </td>
                  <td><%= c.client_ref_no %></td>
                  <td>
                    <%= c.user&.name %>
                    <br />
                    <span class="badge badge-pill badge-dark"><%= c.status %></span><br />
                    
                    <%if c.is_untraceable.present? %> 
                      <span class="badge badge-pill badge-warning", style="margin-top: 5px;">Untraceable</span>
                    <% end %><br />
                  </td>
                  <td><%= link_to 'Template', template_executive_case_path(c) %></td>
                </tr>
              <% end %>
            </tbody>
          </table>
        </div>
        <% end %>
        <% else %>
        <strong style="padding: 10px; text-align: center;"> You don't have Cases </strong>
      <%end %>
    </div>
  </div>
</div>

app/views/staff/cases/show.html.erb
<link rel="stylesheet" href="https://unpkg.com/jcrop/dist/jcrop.css">
<script src="https://unpkg.com/jcrop"></script>

<div style='position: fixed; right: 10px; background:#fff; padding: 10px;'>
  <strong><%= @case.client.name %></strong>
  <br />
  <small>
    Received on <%= @case.received_date.strftime('%d %b, %Y') %>
    <% if @case.user.present? %>
      <br />
      Assgned to <%= @case.user.name %>
  <% end %>
    <br />
    Status: <%= @case.status.humanize %>
  </small>
</div>

<div class = "row" >
  <div class="col-lg-8 offset-lg-2 ">
    <div class="card card-small mb-4">
      <div class="card-header border-bottom">
        <h6 class="m-0">Case Details</h6>
      </div>
      <ul class="list-group list-group-flush">
        <li class="list-group-item p-3">
          <div class="row">
            <div class="col">
              <%= form_for :case_investigation, url: upload_verification_detail_executive_case_path(@case),
              :html => { :multipart => true } do |f| %>
                  <%= fields_for "case_investigation[extras]", OpenStruct.new(@case_investigation.extras) do |e| %>
                    <%= render "executive/cases/edit_formats/#{@case.client.client_format}_#{@case.case_type}", f: f, e: e %>

                    <% if @case.attachments.present? %>
                      <div class="uploaded-attachments">
                        <h6>Uploaded Files</h6>

                        <div class="row">
                          <% @case.attachments.each do |attachment| %>
                            <div class="col col-lg-3 text-center">
                              <%= image_tag attachment.document.url, class: 'thumbnail' %>
                              <br />
                              <%= link_to attachment.document_file_name, staff_case_attachment_path(@case, attachment), remote: true %>
                            </div>
                          <% end %>
                        </div>
                      </div>
                    <% end %>

                    <div class="form-group row">
                      <%= fields_for :attachment do |a| %>
                        <div class="col-lg-6" style="padding-top: 100px;">
                            <%= a.label :"Upload documents" %>
                        </div>
                        <div class="col-lg-6">
                          <%= a.file_field :document, name: "attachments[][document]", class: "form-control" %><br />
                          <%= a.file_field :document, name: "attachments[][document]", class: "form-control" %><br />
                          <%= a.file_field :document, name: "attachments[][document]", class: "form-control" %><br />
                          <%= a.file_field :document, name: "attachments[][document]", class: "form-control" %><br />
                          <%= a.file_field :document, name: "attachments[][document]", class: "form-control" %><br />
                          </div>
                        <% end %>
                    </div>
                  
                    <% if @case.status == "verification_completed" %>
                      <%= link_to "Approve", mark_approved_staff_case_path(@case), class: "btn btn-accent" %>
                    <% end %>
                    <% if @case.status == 'approved' %>
                      <span class="text-success">Approved</span>
                    <% end %>
                    <button type="submit" class="btn btn-accent">Submit</button>
                  <% end %>
              <% end %>
              
            </div>
          </div>
        </li>
      </ul>
    </div>
  </div>
</div>

app/views/staff/cases/upload_file.html.erb
<div class="row" style="padding-top: 50px;">
  <div class="col"> 
    <div class="card card-small col-md-8 offset-2 mb-2">
      <div class="card-header border-bottom">
        <%= form_for :cases, url: upload_mapping_staff_cases_path, html: {multipart: true}  do |f| %>
          <div class="form-group">
            <span>Select Client</span> 
            <%= select_tag 'client_id', options_for_select(@clients.collect { |c| [c.name, c.id] }, selected: params[:client_id]), class: 'form-control'  %>
          </div>

          <div class="form-group">
            <%= select_tag :case_type, options_for_select(Case::CASE_TYPES.collect{|k,v| [v, k]}, {selected: params[:case_type], :include_blank => '-- Select --'}),class: 'form-control' %>
          </div>
          
          <div class="form-group">
            <%= file_field_tag :"csv", class: 'form-control'  %>
          </div>

          <div class="form-group">
            <%= f.submit "Next", class: "btn btn-accent" %>
          </div>

          <hr />

          <div class="form-group">
            <%= render "case_formats_preview" %>
          </div>
        <% end %>
      </div>
    </div>
  </div>
</div>


<script type="text/javascript">
  function showDiv()
    {
      var client_name = $('#client_id option[value=' + $('#client_id').val() + ']').text().toLowerCase();
      var case_type = $('#case_type').val();

      $('.format-previews').hide();
      $('#' + client_name + "_" + case_type).show();
    }
    $(document).ready(function(){
      $('#client_id, #case_type').change(showDiv).trigger('change');
    });
</script>

app/views/staff/cases/upload_mapping.html.erb
<div class="row">
  <div class="col">
    <div class="card card-small mb-4">
      <div class="card-header border-bottom">
        <h6 class="m-0">Cases to upload</h6>
      </div>
      <%= form_for :case, url: upload_staff_cases_path do |f| %>
      <% if @cases.present? %>
      <div class="card-body p-0 pb-3 text-center">
        <table class="table mb-0">
          <thead class="bg-light">
            <tr>
              <th class="border-0">Candidate Name</th>
              <th class="border-0">Ref No</th>
              <th class="border-0">Address</th>
            </tr>
          </thead>
          <tbody>
            <% @cases.each do |c| %>
              <tr>
                <td><%= c[:candidate_name] %></td>
                <td><%= c[:client_ref_no] %></td>
                <td><%= c[:address]&.force_encoding('utf-8') %></td>
              </tr>
            <% end %>
          </tbody>
        </table>
      </div>
      <% else %>
        <strong> You don't have cases </strong>
      <% end %>
      <div style="padding: 20px;">
        <button type="submit" class="btn btn-accent">Upload</button>
      </div>
      <% end %>
    </div>
  </div>
</div>